Loading...
Searching...
No Matches
pdftron::PDF::ElementWriter Class Reference

`#include <ElementWriter.h>`

## Public Types
enum | WriteMode { e_underlay , e_overlay , e_replacement }

## Public Member Functions
| ElementWriter ()
| ~ElementWriter ()
void | Begin (Page &page, WriteMode placement=e_overlay, bool page_coord_sys=true, bool compress=true, SDF::Obj resources=0)
void | Begin (SDF::SDFDoc &doc, bool compress=true)
void | Begin (SDF::Obj stream_obj_to_update, bool compress=true, SDF::Obj resources=0)
SDF::Obj | End ()
void | WriteElement (Element element)
void | WritePlacedElement (Element element)
void | Flush ()
void | WriteBuffer (std::vector< unsigned char > data)
void | WriteBuffer (const char *data, int data_sz)
void | WriteString (const char *str)
void | WriteGStateChanges (Element element)
void | SetDefaultGState (ElementReader &reader)
void | Destroy ()

## Detailed Description

ElementWriter can be used to assemble and write new content to a page, Form XObject, Type3 Glyph stream, pattern stream, or any other content stream.

Definition at line 22 of file ElementWriter.h.

## Member Enumeration Documentation

## ◆ WriteMode

enum pdftron::PDF::ElementWriter::WriteMode

Enumeration describing the placement of the element written to a page.

Enumerator
e_underlay | element is put in the background layer of the page
e_overlay | element appears on top of the existing graphics
e_replacement | element will replace current page contents

Definition at line 33 of file ElementWriter.h.

## Constructor & Destructor Documentation

## ◆ ElementWriter()

pdftron::PDF::ElementWriter::ElementWriter | ( |  | ) |

## ◆ ~ElementWriter()

pdftron::PDF::ElementWriter::~ElementWriter | ( |  | ) |

## Member Function Documentation

## ◆ Begin() [1/3]

void pdftron::PDF::ElementWriter::Begin | ( | Page & | page,
|  | WriteMode | placement = e_overlay,
|  | bool | page_coord_sys = true,
|  | bool | compress = true,
|  | SDF::Obj | resources = 0 )

Begin writing to the given page.

By default, new content will be appended to the page, as foreground graphics. It is possible to add new page content as background graphics by setting the second parameter in begin method to 'true' (e.g. writer.Begin(page, true)).

Parameters

  page | The page to write content.
  placement | An optional flag indicating whether the new content should be added as a foreground or background layer to the existing page. By default, the new content will appear on top of the existing graphics.
  page_coord_sys | An optional flag used to select the target coordinate system if true (default), the coordinates are relative to the lower-left corner of the page, otherwise the coordinates are defined in PDF user coordinate system (which may, or may not coincide with the page coordinates).
  compress | An optional flag indicating whether the page content stream should be compressed. This may be useful for debugging content streams. Also some applications need to do a clear text search on strings in the PDF files. By default, all content streams are compressed.
  resources | the resource dictionary in which to store resources for the final page. By default, a new resource dictionary will be created.

## ◆ Begin() [2/3]

void pdftron::PDF::ElementWriter::Begin | ( | SDF::Obj | stream_obj_to_update,
|  | bool | compress = true,
|  | SDF::Obj | resources = 0 )

Begin writing an Element sequence to a stream. Use this function to write Elements to a content stream which will replace an existing content stream in an object passed as a parameter.

Parameters

  stream_obj_to_update | - A low-level SDF stream object that will contain the new stream. Old stream inside that object will be discarded.
  compress | An optional flag indicating whether the content stream should be compressed. This may be useful for debugging content streams. Also some applications need to do a clear text search on strings in the PDF files. By default, all content streams are compressed.
  resources | the resource dictionary in which to store resources for the final page. By default, a new resource dictionary will be created.

Note
  The content stream object is returned when writing operations are completed (i.e. after the call to ElementWriter::End()).

## ◆ Begin() [3/3]

void pdftron::PDF::ElementWriter::Begin | ( | SDF::SDFDoc & | doc,
|  | bool | compress = true )

Begin writing an Element sequence to a new stream. Use this function to write Elements to a content stream other than the page. For example, you can create Form XObjects (See Section '4.9 Form XObjects' in PDF Reference for more details) pattern streams, Type3 font glyph streams, etc.

Parameters

  doc | - A low-level SDF/Cos document that will contain the new stream. You can access low-level document using PDFDoc::GetSDFDoc() or Obj::GetDoc() methods.
  compress | An optional flag indicating whether the page content stream should be compressed. This may be useful for debugging content streams. Also some applications need to do a clear text search on strings in the PDF files. By default, all content streams are compressed.

Note
  the newly created content stream object is returned when writing operations are completed (i.e. after the call to ElementWriter::End()).

## ◆ Destroy()

void pdftron::PDF::ElementWriter::Destroy | ( |  | ) |

Frees the native memory of the object.

## ◆ End()

SDF::Obj pdftron::PDF::ElementWriter::End | ( |  | ) |

Finish writing to a page

Returns
  A low-level stream object that was used to store Elements.

## ◆ Flush()

void pdftron::PDF::ElementWriter::Flush | ( |  | ) |

The Flush method flushes all pending Element writing operations. This method is typically only required to be called when intermixing direct content writing (i.e. WriteBuffer/WriteString) with Element writing.

## ◆ SetDefaultGState()

void pdftron::PDF::ElementWriter::SetDefaultGState | ( | ElementReader & | reader | ) |

This method is used to initialize ElementWriter state with the state of a given ElementReader. This can be used to avoid incorrectly writing inherited GState attributes.

Parameters

  reader | ElementReader.

## ◆ WriteBuffer() [1/2]

void pdftron::PDF::ElementWriter::WriteBuffer | ( | const char * | data,
|  | int | data_sz )

## ◆ WriteBuffer() [2/2]

void pdftron::PDF::ElementWriter::WriteBuffer | ( | std::vector< unsigned char > | data | ) |

Writes an arbitrary buffer to the content stream. This function can be used to insert comments, inline-image data, and chunks of arbitrary content to the output stream.

## ◆ WriteElement()

void pdftron::PDF::ElementWriter::WriteElement | ( | Element | element | ) |

Writes the Element to the content stream.

Parameters

  element | The element to write to the content stream.

## ◆ WriteGStateChanges()

void pdftron::PDF::ElementWriter::WriteGStateChanges | ( | Element | element | ) |

Write only the graphics state changes applied to this element and skip writing the element itself. This is especially useful when rewriting page content, but with the intention to skip certain elements.

Parameters

  element | The element for which to write graphics state changes.

## ◆ WritePlacedElement()

void pdftron::PDF::ElementWriter::WritePlacedElement | ( | Element | element | ) |

A utility function that surrounds the given Element with a graphics state Save/Restore Element (i.e. in PDF content stream represented as 'q element Q').

The function is equivalent to calling WriteElement three times: WriteElement(eSave); WriteElement(element); WriteElement(eRestore);

where eSave is 'e_group_begin' and eRestore is 'e_group_end' Element

The function is useful when XObjects such as Images and Forms are drawn on the page.

Parameters

  element | Element object to enact function on.

## ◆ WriteString()

void pdftron::PDF::ElementWriter::WriteString | ( | const char * | str | ) |

Writes an arbitrary string to the content stream. Serves the same purpose as WriteBuffer().

Parameters

  str | String to write to the content stream.

The documentation for this class was generated from the following file:

- PDF/ElementWriter.h